Index: /code/branches/Boxhead_FS19/data/levels/Hover.oxw
===================================================================
--- /code/branches/Boxhead_FS19/data/levels/Hover.oxw	(revision 12260)
+++ /code/branches/Boxhead_FS19/data/levels/Hover.oxw	(revision 12261)
@@ -10,16 +10,15 @@
 
 <?lua
-  include("HUDTemplates3.oxo")
-  include("templates/spaceshipSwallow.oxt")
-  include("templates/spaceshipPirate.oxt")
+  
   include("templates/spaceshipEscort.oxt")
-  include("templates/spaceshipGhost.oxt")
-  include("templates/spaceshipCollateralDamage.oxt")
-  include("templates/spaceshipAssff.oxt")
-  include("templates/spaceshipAssff2.oxt")
-  include("templates/spaceshipTransporter.oxt")
-
-
 ?>
+<!-- include("HUDTemplates3.oxo") -->
+  <!-- include("templates/spaceshipSwallow.oxt") -->
+  <!-- include("templates/spaceshipPirate.oxt") -->
+  <!-- include("templates/spaceshipEscort.oxt") -->
+  <!-- include("templates/spaceshipCollateralDamage.oxt") -->
+  <!-- include("templates/spaceshipAssff.oxt") -->
+  <!-- include("templates/spaceshipAssff2.oxt") -->
+  <!-- include("templates/spaceshipTransporter.oxt") -->
 
 <LevelInfo
@@ -37,5 +36,5 @@
 
 <?lua
-  include("templates/spaceshipPirate.oxt")
+  include("templates/spaceshipGhost.oxt")
   include("templates/spaceshipHover.oxt")
   include("overlays/HoverHUD.oxo")
@@ -45,5 +44,5 @@
 MAZE_NUM_CELLS = 10
 MAZE_CELL_SIZE = 100
-MAZE_CELL_HEIGHT = 30
+MAZE_CELL_HEIGHT = 100
 MAZE_SIZE = MAZE_NUM_CELLS*MAZE_CELL_SIZE
 ?>
@@ -108,5 +107,5 @@
     <SpaceShip position="100,20,100" lookat="50,20,50" name="enemy" health="200" maxhealth="200" initialhealth="200" >
                                     <templates>
-                                            <Template link=spaceshipghost />
+                                            <Template link=spaceshiphover />
                                       </templates>
                                        <controller>
Index: /code/branches/Boxhead_FS19/data/levels/includes/weaponSettingsHover.oxi
===================================================================
--- /code/branches/Boxhead_FS19/data/levels/includes/weaponSettingsHover.oxi	(revision 12260)
+++ /code/branches/Boxhead_FS19/data/levels/includes/weaponSettingsHover.oxi	(revision 12261)
@@ -1,5 +1,5 @@
 <weaponslots>
-  <WeaponSlot position="-3,2,-3" />
-  <WeaponSlot position=" 3,2,-3" />
+  <WeaponSlot position="-3,3, 3" />
+  <WeaponSlot position=" 3,3, 3" />
 </weaponslots>
 <weaponsets>
@@ -14,8 +14,8 @@
     </links>
     <Weapon>
-      <IceGun mode=0 munitionpershot=0 delay=0.125 damage=9.3 material="Flares/point_lensflare" muzzleoffset=" 0.1, 1.6,-2" projectileMesh="LaserBeam2.mesh" />
+      <HoverGun mode=0 munitionpershot=0 delay=0.125 damage=9.3 material="Flares/point_lensflare" muzzleoffset=" 0.1, 1.6,-2" projectileMesh="LaserBeam2.mesh" />
     </Weapon>
     <Weapon>
-      <IceGun mode=0 munitionpershot=0 delay=0     damage=9.3 material="Flares/point_lensflare" muzzleoffset=" 1.6, 1.3, -2.0" projectileMesh="LaserBeam2.mesh" />
+      <HoverGun mode=0 munitionpershot=0 delay=0     damage=9.3 material="Flares/point_lensflare" muzzleoffset=" 1.6, 1.3, -2.0" projectileMesh="LaserBeam2.mesh" />
     </Weapon>
   </WeaponPack>
Index: /code/branches/Boxhead_FS19/data/levels/templates/spaceshipGhost.oxt
===================================================================
--- /code/branches/Boxhead_FS19/data/levels/templates/spaceshipGhost.oxt	(revision 12260)
+++ /code/branches/Boxhead_FS19/data/levels/templates/spaceshipGhost.oxt	(revision 12261)
@@ -59,5 +59,5 @@
     </explosion>
 <?lua
-  include("../includes/weaponSettingsHover.oxi")
+  include("../includes/weaponSettingsGhost.oxi")
 ?>
   </SpaceShip>
Index: /code/branches/Boxhead_FS19/data/levels/templates/spaceshipHover.oxt
===================================================================
--- /code/branches/Boxhead_FS19/data/levels/templates/spaceshipHover.oxt	(revision 12260)
+++ /code/branches/Boxhead_FS19/data/levels/templates/spaceshipHover.oxt	(revision 12261)
@@ -61,5 +61,5 @@
 
 <?lua
-  include("../includes/weaponSettingsHeartAttack.oxi")
+  include("../includes/weaponSettingsHover.oxi")
 ?>
   </SpaceShip>
Index: /code/branches/Boxhead_FS19/src/modules/hover/Hover.h
===================================================================
--- /code/branches/Boxhead_FS19/src/modules/hover/Hover.h	(revision 12260)
+++ /code/branches/Boxhead_FS19/src/modules/hover/Hover.h	(revision 12261)
@@ -27,5 +27,5 @@
  */
 
-/**
+/**f
     @file Hover.h
     @brief Gametype. For more information see .cc file
Index: /code/branches/Boxhead_FS19/src/modules/weapons/projectiles/IceGunProjectile.cc
===================================================================
--- /code/branches/Boxhead_FS19/src/modules/weapons/projectiles/IceGunProjectile.cc	(revision 12260)
+++ /code/branches/Boxhead_FS19/src/modules/weapons/projectiles/IceGunProjectile.cc	(revision 12261)
@@ -60,5 +60,5 @@
 
         Model* model = new Model(this->getContext());
-        model->setMeshSource("IceBolt.mesh");
+        model->setMeshSource("laserbeam.mesh");
         model->setScale(15.0);
         this->attach(model);