Index: code/branches/Boxhead_FS19/data/defaultConfig/keybindings.ini
===================================================================
--- code/branches/Boxhead_FS19/data/defaultConfig/keybindings.ini	(revision 12262)
+++ code/branches/Boxhead_FS19/data/defaultConfig/keybindings.ini	(revision 12267)
@@ -167,5 +167,5 @@
 XNeg="scale 1 rotateYaw"
 XPos="scale -1 rotateYaw"
-YNeg=
-YPos=
+YNeg="scale -1 rotatePitch"
+YPos="scale 1 rotatePitch"
 
Index: code/branches/Boxhead_FS19/data/levels/Hover.oxw
===================================================================
--- code/branches/Boxhead_FS19/data/levels/Hover.oxw	(revision 12262)
+++ code/branches/Boxhead_FS19/data/levels/Hover.oxw	(revision 12267)
@@ -1,16 +1,2 @@
-<?lua
-  include("stats.oxo")
-  include("HUDTemplates3.oxo")
-  include("templates/lodInformation.oxt")
-  include("templates/pickupRepresentationTemplates.oxt")
-
-?>
-
-
-
-<?lua
-  
-  include("templates/spaceshipEscort.oxt")
-?>
 <!-- include("HUDTemplates3.oxo") -->
   <!-- include("templates/spaceshipSwallow.oxt") -->
@@ -41,4 +27,36 @@
 ?>
 
+
+
+
+
+
+
+
+ <?lua
+  include("stats.oxo")
+  include("HUDTemplates3.oxo")
+  include("templates/lodInformation.oxt")
+  include("templates/pickupRepresentationTemplates.oxt")
+
+?>
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
 <?lua
 MAZE_NUM_CELLS = 10
@@ -51,4 +69,5 @@
 plugins = hover
 gametype = Hover
+
 
 >
Index: code/branches/Boxhead_FS19/data/levels/templates/spaceshipGhost.oxt
===================================================================
--- code/branches/Boxhead_FS19/data/levels/templates/spaceshipGhost.oxt	(revision 12262)
+++ code/branches/Boxhead_FS19/data/levels/templates/spaceshipGhost.oxt	(revision 12267)
@@ -7,17 +7,11 @@
    explosionchunks        = 6
 
-   health            = 30
-   maxhealth         = 50
-   initialhealth     = 30
+   health            = 100
+   maxhealth         = 100
+   initialhealth     = 100
+  
 
-   shieldhealth        = 100
-   initialshieldhealth = 100
-   maxshieldhealth     = 150
-   shieldabsorption    = 0.9
-   shieldrechargerate  = 3
-   shieldrechargewaittime = 0.0
-
-   primaryThrust     = 600
-   auxilaryThrust    = 30
+   primaryThrust     = 25
+   auxilaryThrust    = 25
    rotationThrust    = 25
 
@@ -25,8 +19,5 @@
    stallSpeed = 100;
 
-   boostPower            = 30
-   boostPowerRate        = 1
-   boostRate             = 5
-   boostCooldownDuration = 15
+
 
    shakeFrequency = 20
@@ -58,8 +49,8 @@
       <ExplosionPart mesh="WingDebris2.mesh" effect1="Orxonox/fire4" effect2="Orxonox/smoke6" />
     </explosion>
-<?lua
+<!-- <?lua
   include("../includes/weaponSettingsGhost.oxi")
 ?>
-  </SpaceShip>
+ -->  </SpaceShip>
 </Template>
 
@@ -78,5 +69,5 @@
    boostfactor    = 2
 
-   speedfront     =  25
+   speedfront     =  50
    speedback      =  50
    speedleftright =  50
@@ -87,5 +78,5 @@
    accelerationback      =  100
    accelerationleftright =  100
-   accelerationupdown    =  100
+   accelerationupdown    =  0
   >
     <EffectContainer condition="normal or boost">
Index: code/branches/Boxhead_FS19/data/levels/templates/spaceshipHover.oxt
===================================================================
--- code/branches/Boxhead_FS19/data/levels/templates/spaceshipHover.oxt	(revision 12262)
+++ code/branches/Boxhead_FS19/data/levels/templates/spaceshipHover.oxt	(revision 12267)
@@ -20,5 +20,5 @@
    primaryThrust     = 200
    auxilaryThrust    = 30
-   rotationThrust    = 25
+   rotationThrust    = 20
 
    jumpBoost = 90
Index: code/branches/Boxhead_FS19/src/modules/hover/Hover.cc
===================================================================
--- code/branches/Boxhead_FS19/src/modules/hover/Hover.cc	(revision 12262)
+++ code/branches/Boxhead_FS19/src/modules/hover/Hover.cc	(revision 12267)
@@ -39,4 +39,6 @@
 #include "MazeGenerator.h"
 #include "core/CoreIncludes.h"
+    
+
 
 namespace orxonox
Index: code/branches/Boxhead_FS19/src/modules/hover/HoverWall.cc
===================================================================
--- code/branches/Boxhead_FS19/src/modules/hover/HoverWall.cc	(revision 12262)
+++ code/branches/Boxhead_FS19/src/modules/hover/HoverWall.cc	(revision 12267)
@@ -1,3 +1,3 @@
-/*
+    /*
  *   ORXONOX - the hottest 3D action shooter ever to exist
  *                    > www.orxonox.net <