Index: code/branches/OrxoBlox_FS19/data/levels/orxoblox.oxw
===================================================================
--- code/branches/OrxoBlox_FS19/data/levels/orxoblox.oxw	(revision 12267)
+++ code/branches/OrxoBlox_FS19/data/levels/orxoblox.oxw	(revision 12268)
@@ -9,10 +9,10 @@
   include("HUDTemplates3.oxo")
   include("stats.oxo")
-  include("pongHUD.oxo")
+  include("OrxoBloxHUD.oxo")
   include("templates/lodInformation.oxt")
 ?>
 
-<Template name=pongbatcameras defaults=0>
-  <PongBat>
+<Template name=OrxoBloxbatcameras defaults=0>
+  <OrxoBloxBat>
     <camerapositions>
       <CameraPosition position="0,150,0" pitch=-90 absolute=true />
@@ -21,18 +21,18 @@
       <CameraPosition position="0,30, 90" drag=true mouselook=true />
     </camerapositions>
-  </PongBat>
+  </OrxoBloxBat>
 </Template>
 
-<Template name=pongbat>
-  <PongBat camerapositiontemplate=pongbatcameras>
+<Template name=OrxoBloxbat>
+  <OrxoBloxBat camerapositiontemplate=OrxoBloxbatcameras>
     <attached>
       <Model position="0,0,3" mesh="cube.mesh" scale3D="14,2,2" />
-      <!--Model roll=180 mesh="pongbat.mesh" scale=0.045 /-->
+      <!--Model roll=180 mesh="OrxoBloxbat.mesh" scale=0.045 /-->
     </attached>
-  </PongBat>
+  </OrxoBloxBat>
 </Template>
 
-<Template name=pongball>
-  <PongBall 
+<Template name=OrxoBloxball>
+  <OrxoBloxBall 
    defScoreSound = "sounds/PlayerWinScore_cut.ogg"
    defBatSound = "sounds/Button.ogg"
@@ -48,5 +48,5 @@
       <EventTarget target=hiteffect />
     </eventlisteners>
-  </PongBall>
+  </OrxoBloxBall>
 </Template>
 
@@ -55,5 +55,5 @@
 <Level
   plugins = "OrxoBlox_FS19"
- gametype = "OrxoBlox"
+ gametype = "Pong"
 >
 
@@ -64,5 +64,5 @@
 
   <WorldAmbientSound source="Ganymede.ogg" looping="true" playOnLoad="true"/>
-  <PongBot />
+  <OrxoBloxBot />
 
   <Scene
@@ -76,5 +76,5 @@
     <MovableEntity rotationrate=5 rotationaxis="0,0,1">
       <attached>
-        <PongCenterpoint name=pongcenter dimension="200,120" balltemplate=pongball battemplate=pongbat ballspeed=200 ballaccfactor=1.0 batspeed=130 batlength=0.25>
+        <OrxoBloxCenterpoint name=OrxoBloxcenter dimension="200,120" balltemplate=OrxoBloxball battemplate=OrxoBloxbat ballspeed=200 ballaccfactor=1.0 batspeed=130 batlength=0.25>
           <attached>
             <Model position="0,0,60" mesh="cube.mesh" scale3D="105,1,1" />
@@ -97,10 +97,10 @@
             <ParticleSpawner name=scoreeffect_left position="-120,0,-45" source="Orxonox/sparks2" lifetime=0.1 autostart=0 />
 
-<!-- TODO: Create a Pong Score Sound and include it here.
+<!-- TODO: Create a OrxoBlox Score Sound and include it here.
 This WorldSound works, but doesn't make sense, since it is played together with ambient/moodDependedDirectory/Ganymede.ogg -->
-            <!--WorldSound name="scoreSound" position="0,0,0" source="sounds/PongScore_cut.ogg" >
+            <!--WorldSound name="scoreSound" position="0,0,0" source="sounds/OrxoBloxScore_cut.ogg" >
               <events>
                 <play>
-                  <EventListener event=pongcenter />
+                  <EventListener event=OrxoBloxcenter />
                 </play>
               </events>
@@ -114,5 +114,5 @@
 
           </attached>
-        </PongCenterpoint>
+        </OrxoBloxCenterpoint>
       </attached>
     </MovableEntity>
@@ -129,5 +129,5 @@
               <EventName name=right />
             </names>
-            <EventListener event=pongcenter />
+            <EventListener event=OrxoBloxcenter />
           </EventFilter>
         </spawn>
@@ -145,5 +145,5 @@
               <EventName name=left />
             </names>
-            <EventListener event=pongcenter />
+            <EventListener event=OrxoBloxcenter />
           </EventFilter>
         </spawn>
Index: code/branches/OrxoBlox_FS19/data/overlays/OrxoBloxHUD.oxo
===================================================================
--- code/branches/OrxoBlox_FS19/data/overlays/OrxoBloxHUD.oxo	(revision 12268)
+++ code/branches/OrxoBlox_FS19/data/overlays/OrxoBloxHUD.oxo	(revision 12268)
@@ -0,0 +1,70 @@
+<Template name="OrxoBloxHUD">
+  <OverlayGroup name="OrxoBloxHUD" scale = "1, 1">
+    <OrxoBloxScore
+     position  = "0.05, 0.05"
+     pickpoint = "0.0, 0.0"
+     font      = "ShareTechMono"
+     textsize  = 0.06
+     colour    = "1.0, 1.0, 1.0, 1.0"
+     align     = "left"
+
+     showleftplayer  = true
+     showrightplayer = false
+     showname        = true
+     showscore       = false
+    />
+
+    <OrxoBloxScore
+     position  = "0.49, 0.05"
+     pickpoint = "0.0, 0.0"
+     font      = "ShareTechMono"
+     textsize  = 0.06
+     colour    = "1.0, 1.0, 1.0, 1.0"
+     align     = "right"
+
+     showleftplayer  = true
+     showrightplayer = false
+     showname        = false
+     showscore       = true
+    />
+
+    <OverlayText
+     position  = "0.505, 0.05"
+     pickpoint = "0.0, 0.0"
+     font      = "ShareTechMono"
+     textsize  = 0.06
+     colour    = "1.0, 1.0, 1.0, 1.0"
+     align     = "center"
+
+     caption   = ":"
+    />
+
+    <OrxoBloxScore
+     position  = "0.51, 0.05"
+     pickpoint = "0.0, 0.0"
+     font      = "ShareTechMono"
+     textsize  = 0.06
+     colour    = "1.0, 1.0, 1.0, 1.0"
+     align     = "left"
+
+     showleftplayer  = false
+     showrightplayer = true
+     showname        = false
+     showscore       = true
+    />
+
+    <OrxoBloxScore
+     position  = "0.95, 0.05"
+     pickpoint = "0.0, 0.0"
+     font      = "ShareTechMono"
+     textsize  = 0.06
+     colour    = "1.0, 1.0, 1.0, 1.0"
+     align     = "right"
+
+     showleftplayer  = false
+     showrightplayer = true
+     showname        = true
+     showscore       = false
+    />
+  </OverlayGroup>
+</Template>
Index: code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/CMakeLists.txt
===================================================================
--- code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/CMakeLists.txt	(revision 12267)
+++ code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/CMakeLists.txt	(revision 12268)
@@ -6,5 +6,5 @@
   BallGun/BallProjectile.cc
   OrxoBlox.cc
-  OrxoBloxAI.cc
+  
   OrxoBloxBall.cc
   OrxoBloxBat.cc
Index: code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBlox.cc
===================================================================
--- code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBlox.cc	(revision 12267)
+++ code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBlox.cc	(revision 12268)
@@ -46,5 +46,5 @@
 #include "OrxoBloxBat.h"
 #include "OrxoBloxBot.h"
-#include "OrxoBloxAI.h"
+#include "OrxoBloxStones.h"
 
 namespace orxonox
@@ -75,5 +75,5 @@
 
         // Set the type of Bots for this particular Gametype.
-        this->botclass_ = Class(OrxoBloxBot);
+        this->botclass_ = Class(OrxoBloxBat);
 
         this->scoreLimit_ = 10;
@@ -193,4 +193,5 @@
     void OrxoBlox::end()
     {
+        ChatManager::message("You suck!!");
         this->cleanup();
 
@@ -233,11 +234,4 @@
         else
             return;
-
-        // If the player is an AI, it receives a pointer to the ball.
-        if (player->getController() != nullptr && player->getController()->isA(Class(OrxoBloxAI)))
-        {
-            OrxoBloxAI* ai = orxonox_cast<OrxoBloxAI*>(player->getController());
-            ai->setOrxoBloxBall(this->ball_);
-        }
     }
 
@@ -278,14 +272,4 @@
         }
 
-        // If a player gets enough points, he won the game -> end of game
-        PlayerInfo* winningPlayer = nullptr;
-        if (this->getLeftPlayer() && this->getScore(this->getLeftPlayer()) >= scoreLimit_)
-            winningPlayer = this->getLeftPlayer();
-
-        if (winningPlayer)
-        {
-             ChatManager::message(winningPlayer->getName() + " has won!");
-             this->end();
-        }
 
         // Restart the timer to start the ball.
@@ -317,10 +301,4 @@
     }
 
-    /**
-    @brief
-        Get the right player.
-    @return
-        Returns a pointer to the player playing on the right. If there is no right player, nullptr is returned.
-    */
     
 }
Index: code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBlox.h
===================================================================
--- code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBlox.h	(revision 12267)
+++ code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBlox.h	(revision 12268)
@@ -84,5 +84,4 @@
 
             PlayerInfo* getLeftPlayer() const; //!< Get the left player.
-            PlayerInfo* getRightPlayer() const; //!< Get the right player.
 
         protected:
Index: code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBloxBot.cc
===================================================================
--- code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBloxBot.cc	(revision 12267)
+++ code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBloxBot.cc	(revision 12268)
@@ -35,5 +35,4 @@
 
 #include "core/CoreIncludes.h"
-#include "OrxoBloxAI.h"
 
 namespace orxonox
@@ -49,6 +48,5 @@
         RegisterObject(OrxoBloxBot);
 
-        this->defaultController_ = Class(OrxoBloxAI);
-        this->createController();
+        
     }
 }