Index: code/branches/Boxhead_FS19/data/levels/Hover.oxw
===================================================================
--- code/branches/Boxhead_FS19/data/levels/Hover.oxw	(revision 12267)
+++ code/branches/Boxhead_FS19/data/levels/Hover.oxw	(revision 12273)
@@ -1,11 +1,2 @@
-<!-- include("HUDTemplates3.oxo") -->
-  <!-- include("templates/spaceshipSwallow.oxt") -->
-  <!-- include("templates/spaceshipPirate.oxt") -->
-  <!-- include("templates/spaceshipEscort.oxt") -->
-  <!-- include("templates/spaceshipCollateralDamage.oxt") -->
-  <!-- include("templates/spaceshipAssff.oxt") -->
-  <!-- include("templates/spaceshipAssff2.oxt") -->
-  <!-- include("templates/spaceshipTransporter.oxt") -->
-
 <LevelInfo
  name = "Hover level"
Index: code/branches/Boxhead_FS19/data/levels/includes/weaponSettingsHover.oxi
===================================================================
--- code/branches/Boxhead_FS19/data/levels/includes/weaponSettingsHover.oxi	(revision 12267)
+++ code/branches/Boxhead_FS19/data/levels/includes/weaponSettingsHover.oxi	(revision 12273)
@@ -27,4 +27,4 @@
 </weaponpacks>  
 <munition>
-  <IceMunition initialmagazines=1 maxmagazines=1 munitionpermagazine=10/>
+  <LaserMunition initialmagazines=1 maxmagazines=1 munitionpermagazine=10/>
 </munition>
Index: code/branches/Boxhead_FS19/src/modules/hover/Hover.h
===================================================================
--- code/branches/Boxhead_FS19/src/modules/hover/Hover.h	(revision 12267)
+++ code/branches/Boxhead_FS19/src/modules/hover/Hover.h	(revision 12273)
@@ -27,5 +27,5 @@
  */
 
-/**f
+/**
     @file Hover.h
     @brief Gametype. For more information see .cc file
Index: code/branches/Boxhead_FS19/src/modules/weapons/projectiles/CMakeLists.txt
===================================================================
--- code/branches/Boxhead_FS19/src/modules/weapons/projectiles/CMakeLists.txt	(revision 12267)
+++ code/branches/Boxhead_FS19/src/modules/weapons/projectiles/CMakeLists.txt	(revision 12273)
@@ -15,3 +15,4 @@
   MineProjectile.cc
   WagnisProjectile.cc
+  HoverGunProjectile.cc
 )
Index: code/branches/Boxhead_FS19/src/modules/weapons/projectiles/HoverGunProjectile.cc
===================================================================
--- code/branches/Boxhead_FS19/src/modules/weapons/projectiles/HoverGunProjectile.cc	(revision 12267)
+++ code/branches/Boxhead_FS19/src/modules/weapons/projectiles/HoverGunProjectile.cc	(revision 12273)
@@ -21,23 +21,20 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Joel Smely
  *   Co-authors:
- *      simonmie
+ *      ...
  *
  */
 
 /**
-    @file Projectile.h
-    @brief Implementation of the Projectile class.
+    @file HoverGunProjectile.h
+    @brief Implementation of the HoverGunProjectile class.
 */
 
 #include "HoverGunProjectile.h"
 
-#include "core/config/ConfigValueIncludes.h"
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
 #include "core/command/Executor.h"
-
-#include "worldentities/pawns/Pawn.h"
+#include "util/Convert.h"
 
 namespace orxonox
@@ -45,57 +42,46 @@
     RegisterClass(HoverGunProjectile);
 
-    HoverGunProjectile::HoverGunProjectile(Context* context) : MovableEntity(context), BasicProjectile()
+    HoverGunProjectile::HoverGunProjectile(Context* context) : BillboardProjectile(context)
     {
         RegisterObject(HoverGunProjectile);
 
-        this->setConfigValues();
+        this->textureIndex_ = 1;
+        this->setMass(0.1f);
+        this->setCollisionType(CollisionType::Dynamic);
+        this->maxTextureIndex_ = 8;
+        this->textureTimer_.setTimer(0.01f, true, createExecutor(createFunctor(&HoverGunProjectile::changeTexture, this)));
 
-        // Get notification about collisions
-        if (GameMode::isMaster())
-        {
-            this->setMass(0.1f);
-            this->enableCollisionCallback();
-            this->setCollisionResponse(false);
-            this->setCollisionType(CollisionType::Dynamic);
-
-            // Create a sphere collision shape and attach it to the projectile.
-            collisionShape_ = new SphereCollisionShape(this->getContext());
-            setCollisionShapeRadius(8.0f);
-            this->attachCollisionShape(collisionShape_);
-
-            this->destroyTimer_.setTimer(this->lifetime_, false, createExecutor(createFunctor(&BasicProjectile::destroyObject, this)));
-        }
+        registerVariables();
     }
 
-    HoverGunProjectile::~HoverGunProjectile()
+    void HoverGunProjectile::registerVariables()
     {
+        registerVariable(this->materialBase_);
     }
 
-    void HoverGunProjectile::setConfigValues()
+    /**
+    @brief
+        Set the material.
+    @param material
+        The name of the material. Material names with 1 to 8 appended must exist.
+    */
+    void HoverGunProjectile::setMaterial(const std::string& material)
     {
-        SetConfigValue(lifetime_, 4.0f).description("The time in seconds a projectile stays alive");
+        this->materialBase_ = material;
+
+        BillboardProjectile::setMaterial(material + multi_cast<std::string>(this->textureIndex_));
     }
 
-    void HoverGunProjectile::tick(float dt)
+    /**
+    @brief
+        Change the texture.
+    */
+    void HoverGunProjectile::changeTexture()
     {
-        SUPER(Projectile, tick, dt);
+        this->textureIndex_++;
+        if (this->textureIndex_ > this->maxTextureIndex_)
+            this->textureIndex_ = 1;
 
-        if (!this->isActive())
-            return;
-
-        this->destroyCheck();
-    }
-
-    bool HoverGunProjectile::collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint)
-    {
-        return this->processCollision(otherObject, contactPoint, cs);
-    }
-
-    void HoverGunProjectile::setCollisionShapeRadius(float radius)
-    {
-        if (collisionShape_ != nullptr && radius > 0)
-        {
-            collisionShape_->setRadius(radius);
-        }        
+        this->setMaterial(this->materialBase_);
     }
 }
Index: code/branches/Boxhead_FS19/src/modules/weapons/projectiles/HoverGunProjectile.h
===================================================================
--- code/branches/Boxhead_FS19/src/modules/weapons/projectiles/HoverGunProjectile.h	(revision 12267)
+++ code/branches/Boxhead_FS19/src/modules/weapons/projectiles/HoverGunProjectile.h	(revision 12273)
@@ -21,13 +21,13 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Joel Smely
  *   Co-authors:
- *      simonmie
+ *      ...
  *
  */
 
 /**
-    @file Projectile.h
-    @brief Definition of the Projectile class.
+    @file HoverGunProjectile.h
+    @brief Definition of the HoverGunProjectile class.
 */
 
@@ -37,9 +37,7 @@
 #include "weapons/WeaponsPrereqs.h"
 
+#include <string>
 #include "tools/Timer.h"
-#include "worldentities/MovableEntity.h"
-#include "objects/collisionshapes/SphereCollisionShape.h"
-
-#include "BasicProjectile.h"
+#include "BillboardProjectile.h"
 
 namespace orxonox
@@ -48,32 +46,28 @@
     /**
     @brief
-        Represents all 'standard' projectiles.
-
+        The HoverGunProjectile is a projectile that is represented by a looped series of billboards.
+        
     @author
-        Fabian 'x3n' Landau
-    @author
-        Simon Miescher
+        Joel Smely
     @ingroup WeaponsProjectiles
     */
-    class _WeaponsExport HoverGunProjectile : public MovableEntity, public BasicProjectile
+    class _WeaponsExport HoverGunProjectile : public BillboardProjectile
     {
         public:
             HoverGunProjectile(Context* context);
-            virtual ~HoverGunProjectile();
+            virtual ~HoverGunProjectile() {}
 
-            void setConfigValues();
-
-            virtual void tick(float dt) override;
-            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint) override;
-
-        protected:
-            virtual void setCollisionShapeRadius(float radius);
-            float lifetime_; //!< The time the projectile exists.
+            virtual void setMaterial(const std::string& material) override;
 
         private:
-            Timer destroyTimer_; //!< Timer to destroy the projectile after its lifetime has run out.
-            WeakPtr<SphereCollisionShape> collisionShape_; // The collision shape of the projectile.
+            void registerVariables();
+            void changeTexture();
+            
+            unsigned int textureIndex_; //!< The current index of the texture. (i.e. the index of the currently displayed texture)
+            unsigned int maxTextureIndex_; //!< The maximal index.
+            Timer textureTimer_; //!< A timer that loops and changes textures each time it expires.
+            std::string materialBase_; //!< The base name of the material.
     };
 }
 
-#endif /* _Projectile_H__ */
+#endif /* _HoverGunProjectile_H__ */
Index: code/branches/Boxhead_FS19/src/modules/weapons/weaponmodes/CMakeLists.txt
===================================================================
--- code/branches/Boxhead_FS19/src/modules/weapons/weaponmodes/CMakeLists.txt	(revision 12267)
+++ code/branches/Boxhead_FS19/src/modules/weapons/weaponmodes/CMakeLists.txt	(revision 12273)
@@ -5,4 +5,5 @@
   HsW01.cc
   LightningGun.cc
+  HoverGun.cc
   SplitGun.cc
   IceGun.cc
Index: code/branches/Boxhead_FS19/src/modules/weapons/weaponmodes/HoverGun.cc
===================================================================
--- code/branches/Boxhead_FS19/src/modules/weapons/weaponmodes/HoverGun.cc	(revision 12267)
+++ code/branches/Boxhead_FS19/src/modules/weapons/weaponmodes/HoverGun.cc	(revision 12273)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Hagen Seifert
+ *      Joel Smely
  *   Co-authors:
  *      simonmie
@@ -28,6 +28,6 @@
 
 /**
-    @file HsW01.h
-    @brief Implementation of the HsW01 class.
+    @file HoverGun.h
+    @brief Implementation of the HoverGun class.
 */
 
@@ -35,16 +35,10 @@
 
 #include "core/CoreIncludes.h"
-#include "core/XMLPort.h"
-#include "core/command/Executor.h"
-
-#include "graphics/Model.h"
 #include "weaponsystem/Weapon.h"
 #include "weaponsystem/WeaponPack.h"
 #include "weaponsystem/WeaponSystem.h"
-#include "worldentities/WorldEntity.h"
 #include "worldentities/pawns/Pawn.h"
 
 #include "weapons/projectiles/HoverGunProjectile.h"
-#include "weapons/MuzzleFlash.h"
 
 namespace orxonox
@@ -56,19 +50,12 @@
         RegisterObject(HoverGun);
 
-        this->reloadTime_ = 0.25f;
-        this->damage_ = 0.0f; //default 15
+        this->reloadTime_ = 1.0f;
+        this->damage_ = 0.0f;
         this->speed_ = 750.0f;
-        this->delay_ = 0.0f;
-        this->setMunitionName("LaserMunition");
-        this->mesh_ = "laserbeam.mesh";
 
+        this->setMunitionName("HoverMunition");
+        this->setFireSound("sounds/Weapon_HoverGun.ogg");
 
-        this->delayTimer_.setTimer(this->delay_, false, createExecutor(createFunctor(&HoverGun::shot, this)));
-        this->delayTimer_.stopTimer();
-
-        this->setFireSound("sounds/Weapon_HsW01.ogg");
-        this->setReloadSound("sounds/Reload_HsW01.ogg", 0.5);
-
-        hudImageString_ = "Orxonox/WSHUD_WM_HsW01";
+        hudImageString_ = "Orxonox/WSHUD_WM_HoverGun";
     }
 
@@ -76,31 +63,4 @@
     {
     }
-
-    void HoverGun::XMLPort(Element& xmlelement, XMLPort::Mode mode)
-    {
-        SUPER(HoverGun, XMLPort, xmlelement, mode);
-
-        XMLPortParam(HoverGun, "delay", setDelay, getDelay, xmlelement, mode);
-        XMLPortParam(HoverGun, "material", setMaterial, getMaterial, xmlelement, mode);
-        XMLPortParam(HoverGun, "projectileMesh", setMesh, getMesh, xmlelement, mode);
-        XMLPortParam(HoverGun, "sound", setSound, getSound, xmlelement, mode);
-    }
-
-    /**
-    @brief
-        Set the firing delay.
-    @param delay
-        The firing delay in seconds.
-    */
-    void HoverGun::setDelay(float delay)
-    {
-        this->delay_ = delay;
-        this->delayTimer_.setInterval(this->delay_);
-    }
-
-    // void HoverGun::fire()
-    // {
-    //     this->delayTimer_.startTimer();
-    // }
 
     /**
@@ -110,13 +70,6 @@
     void HoverGun::fire()
     {
-        assert( this->getWeapon() && this->getWeapon()->getWeaponPack() && this->getWeapon()->getWeaponPack()->getWeaponSystem() && this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn() );
-
-        // Create the projectile.
         HoverGunProjectile* projectile = new HoverGunProjectile(this->getContext());
-        Model* model = new Model(HoverGunprojectile->getContext());
-        model->setMeshSource(mesh_);
-        model->setCastShadows(false);
-        projectile->attach(model);
-        model->setScale(5);
+        projectile->setMaterial("Flares/HoverBall_");
 
         this->computeMuzzleParameters(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn()->getAimPosition());
@@ -129,19 +82,4 @@
         projectile->setShieldDamage(this->getShieldDamage());
         projectile->setHealthDamage(this->getHealthDamage());
-
-        // Display the muzzle flash.
-        // this->HoverGun::muzzleflash();
     }
-
-    /**
-    @brief
-        Displays the muzzle flash.
-    */
-    // void HoverGun::muzzleflash()
-    // {
-    //     MuzzleFlash *muzzleFlash = new MuzzleFlash(this->getContext());
-    //     this->getWeapon()->attach(muzzleFlash);
-    //     muzzleFlash->setPosition(this->getMuzzleOffset());
-    //     muzzleFlash->setMaterial(this->material_);
-    // }
 }
Index: code/branches/Boxhead_FS19/src/modules/weapons/weaponmodes/HoverGun.h
===================================================================
--- code/branches/Boxhead_FS19/src/modules/weapons/weaponmodes/HoverGun.h	(revision 12267)
+++ code/branches/Boxhead_FS19/src/modules/weapons/weaponmodes/HoverGun.h	(revision 12273)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Hagen Seifert
+ *      Joel Smely
  *   Co-authors:
  *      ...
@@ -36,6 +36,4 @@
 
 #include "weapons/WeaponsPrereqs.h"
-
-#include "tools/Timer.h"
 #include "weaponsystem/WeaponMode.h"
 
@@ -45,7 +43,7 @@
     /**
     @brief
-        Shoots laser beams.
+        A slow ball of lightning.
     @author
-        Hagen Seifert
+        Joel Smely
     @ingroup WeaponsWeaponModes
     */
@@ -57,70 +55,9 @@
 
             virtual void fire() override;
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
 
-        protected:
-            /**
-            @brief Set the mesh.
-            @param mesh The mesh name.
-            */
-            void setMesh(const std::string& mesh)
-                { this->mesh_ = mesh; }
-
-            /**
-            @brief Get the mesh.
-            @return Returns the mesh name.
-            */
-            const std::string& getMesh() const
-                { return this->mesh_; }
-
-            /**
-            @brief Set the sound.
-            @param sound The Sound name.
-            */
-            void setSound(const std::string& sound)
-                { this->sound_ = sound; }
-
-            /**
-            @brief Get the sound.
-            @return Returns the sound name.
-            */
-            const std::string& getSound() const
-                { return this->sound_; }
-
-            /**
-            @brief Set the material.
-            @param material The material name.
-            */
-            void setMaterial(const std::string& material)
-                { this->material_ = material; }
-            /**
-            @brief Get the material.
-            @return Returns the material name.
-            */
-            const std::string& getMaterial() const
-                { return this->material_; }
-
-            void setDelay(float delay);
-            /**
-            @brief Get the firing delay.
-            @return Returns the firing delay in seconds.
-            */
-            float getDelay() const
-                { return this->delay_; }
-
-            virtual void shot();
-            void muzzleflash();
-
-            std::string material_; //!< The material.
-            std::string mesh_; //!< The mesh.
-            std::string sound_; //!< The sound.
-
-
-
+       private:
             float speed_; //!< The speed of the fired projectile.
-            float delay_; //!< The firing delay.
-            Timer delayTimer_; //!< A timer to delay the firing.
     };
 }
 
-#endif /* HoverGun */
+#endif /* _HoverGun_H__ */