Index: code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/CMakeLists.txt
===================================================================
--- code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/CMakeLists.txt	(revision 12277)
+++ code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/CMakeLists.txt	(revision 12278)
@@ -6,5 +6,5 @@
   BallGun/BallProjectile.cc
   OrxoBlox.cc
-  
+  OrxoBloxWall.cc
   OrxoBloxBall.cc
   OrxoBloxBat.cc
Index: code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBlox.cc
===================================================================
--- code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBlox.cc	(revision 12277)
+++ code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBlox.cc	(revision 12278)
@@ -278,4 +278,11 @@
     }
 
+    /*void OrxoBlox::createStonewall(void){
+        this->futureWall_ = new OrxoBolxWall(this->center_->getContext());
+
+
+
+    }*/
+
     /**
     @brief
Index: code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBloxBall.cc
===================================================================
--- code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBloxBall.cc	(revision 12277)
+++ code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBloxBall.cc	(revision 12278)
@@ -170,4 +170,6 @@
                     // Calculate the distance (in z-direction) between the ball and the center of the bat, weighted by half of the effective length of the bat (with additional 10%)
                     distance = (position.z - this->bat_[1]->getPosition().z) / (this->fieldHeight_ * (this->batlength_ * 1.10f) / 2);
+                    
+
                     if (fabs(distance) <= 1) // If the bat is there to parry.
                     {
@@ -183,14 +185,24 @@
                         this->fireEvent();
                     }
+
                     // If the left player scores.
                     else if (GameMode::isMaster() && position.x > this->fieldWidth_ / 2 * (1 + this->relMercyOffset_))
                     {
+                        ChatManager::message("You suck!!");
                         defScoreSound_->play();//play score sound
                         if (this->getGametype() && this->bat_[0])
                         {
+                            ChatManager::message("You suck!!");
+
+
                             this->getGametype()->playerScored(this->bat_[0]->getPlayer());
                             return;
                         }
                     }
+
+
+
+
+
                 }
                 // If the left boundary has been crossed.
@@ -218,4 +230,6 @@
                         if (this->getGametype() && this->bat_[1])
                         {
+                            ChatManager::message("You suck!!");
+
                             this->getGametype()->playerScored(this->bat_[1]->getPlayer());
                             return;
Index: code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBloxWall.cc
===================================================================
--- code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBloxWall.cc	(revision 12278)
+++ code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBloxWall.cc	(revision 12278)
@@ -0,0 +1,21 @@
+#include "OrxoBloxWall.h"
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+
+#include "OrxoBlox.h"
+
+namespace orxonox
+{
+    RegisterClass(OrxoBloxWall);
+    /**
+    @brief
+        Constructor. Registers and initializes the object.
+    */
+    OrxoBloxWall::OrxoBloxWall(Context* context) : StaticEntity(context)
+    {
+        RegisterObject(OrxoBloxWall);
+
+        this->health_ = 10;
+        this->delay_ = false;
+    }
+}
Index: code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBloxWall.h
===================================================================
--- code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBloxWall.h	(revision 12278)
+++ code/branches/OrxoBlox_FS19/src/modules/OrxoBlox/OrxoBloxWall.h	(revision 12278)
@@ -0,0 +1,58 @@
+#ifndef _OrxoBloxWall_H__
+#define _OrxoBloxWall_H__
+
+
+#include "worldentities/StaticEntity.h"
+#include "tools/Timer.h"
+
+namespace orxonox
+{
+
+    /**
+    @brief
+
+    @author
+
+    @ingroup OrxoBlox
+    */
+    class _OrxoBloxExport OrxoBloxWall : public StaticEntity
+    {
+        public:
+            OrxoBloxWall(Context* context); //!< Constructor. Registers and initializes the object.
+            virtual ~OrxoBloxWall() {}
+             //   this.destroy();
+            //}
+
+            /**
+            @brief Set the Health of the stone.
+            @param size The dimensions a stone has in the game world. (A stone is a cube)
+            */
+            void setHealth(unsigned int health)
+                { 
+                    this->health_ = health; 
+                }
+            /**
+            @brief Get the size of the stone.
+            @return Returns the dimensions a stone has in the game world. (A stone is a cube)
+            */
+            unsigned int getHealth(void) const
+                { return this->health_; }
+
+            void gotHit(){
+                if (this->health_ > 0){
+                    this->health_ -= this->health_; 
+                    }
+                //  else ~OrxoBloxStones();
+                }
+
+
+        private:
+            unsigned int health_;
+            bool delay_;
+            
+            
+
+    };
+}
+
+#endif /* _OrxoBloxWall_H__ */